//+--------------------------------------------------------------------------+
//| 																		 |
#define		Main_title		"AXP-AD02 Sample Program '98/03/02"
#define		Version			"V1.02"
//|			Cording date	1998/03/02										 |
//|			Up date			1998/07/02										 |
//| 																		 |
//+--------------------------------------------------------------------------+
#include <stdlib.h>
#include <stdio.h>
#include <conio.h>
#include <ctype.h>
#include "ad02lib.h"

#define	SAMPLESIZE	100					//ݸސ

static int gCardHd;							//ޏ
static unsigned short gBuff[SAMPLESIZE+1];	//ݸޯ̧
static int gCalRange = -1;					//Z
static CALDATA	gCal;						//Zް

//----- ݼޕύX -----
static void ChgRange(int iRange)
{
char	*szMes;
int		iRes;

	iRes = AD02_cal_prset(iRange,gCardHd);			//ڰްݒ
	if (SUCCESS == iRes){
		szMes = (0 == iRange) ? "}POu" : "}Tu";
		printf("\n%sI",szMes);
		printf("\nZlި̫Ăɖ߂܂");
	} else
		printf("\nݼޕύXװ[%d]",iRes);
}

//----- ŌɍZ̾/޲ݒlݒ -----
static int SetLastCalib(int iNowRange)
{
int	iRange,iRes;

	if (-1 != gCalRange){
		iRes = AD02_cal_adc_load(&gCal,gCardHd);
		if (SUCCESS == iRes){
			printf("\nZlݏI [ݼ:%c]",(0 == gCalRange) ? 'H' : 'L');
			iRange = gCalRange;
		} else {
			printf("\nZlݒװ[%d]",iRes);
			iRange = iNowRange;
		}
	} else {
		printf("\nZĂ܂");
		iRange = iNowRange;
	}
	return(iRange);
}
//----- ݸ -----
static int Sample(int iRange,int iCh,long *lTotal)
{
int		iNum,iKey;

	AD02_mode(iRange,iCh,iCh,10,gCardHd);		//Ӱސݒ
	Sample_start(0,gBuff,SAMPLESIZE,gCardHd);	//ݸ޽
	do {
		if (kbhit()){
			iKey = getch();
			if ('\x1b' == iKey)
				return(iKey);
		}
	} while(SAMPLE_END != AD02_eoc(gCardHd));	//ݸޏI҂
	Sample_stop(gCardHd);						//ݸޒ~
	*lTotal = 0L;								//
	for (iNum=0; iNum < SAMPLESIZE; iNum++)
		*lTotal += gBuff[iNum];
	return(0);
}
//----- ݸް\ -----
static void SampleDisp(int iRange)
{
long	lTotal;
int		iCh;

	printf("\n");
	while(1){
		printf("\r");
		for (iCh=0; iCh < MAXCH; iCh++){
			if ('\x1b' == Sample(iRange,iCh,&lTotal))
				return;
														//ϒl\(ľܓ)
			printf("CH:%d %03X ",iCh+1,(lTotal + 50L) / SAMPLESIZE);
		}
	}
}

//----- ̾/޲ݒ -----
static void Calib(int iRange,int iOffGain)
{
double	fMin,fMax,fTarget,fOffset;
int		iRes;

	if (0 == iRange){
		fMax = +10.0;
		fMin = -10.0;
	} else {
		fMax = +5.0;
		fMin = -5.0;
	}
	if (0 == iOffGain){
		fOffset = ((fMax - fMin) / 4096.0) * 0.5;	//1/2 LSB ߂
		fTarget	= fMin + fOffset;					//̾ēdʒu擾
	} else {
		fOffset = ((fMax - fMin) / 4096.0) * 1.5;	//3/2 LSB ߂
		fTarget	= fMax - fOffset;					//޲ݓdʒu擾
	}
	while(kbhit())
		getch();
	printf("\nCH1 [ %+.4fV ] ͂ĉ",fTarget);
	getch();
	iRes = AD02_cal_control(&gCal,iRange,iOffGain,gCardHd);
	if (SUCCESS == iRes){
		printf("\nZI ");
		printf("%04X,%04X,%04X,%04X,%04X,%04X,%04X,%04X,%04X,%04X"
				,gCal.Gain,gCal.Offset,gCal.Dac1,gCal.Dac2,gCal.Dac3
				,gCal.Dac4,gCal.Dac5,gCal.Dac6,gCal.Dac7,gCal.Dac8
		);
		gCalRange = iRange;
	} else {
		printf("\nZװ[%d]",iRes);
		gCalRange = -1;
	}
}

//----- ̾Ĕ -----
static void OffCalib(int iRange)
{
float	fBit,fVolt,fMin,fMax;
long	lTotal;
int		iRes,iOffset;

	while(kbhit())
		getch();
	printf("\nCH1 [ 0.0000V ] ͂ĉ");
	getch();
	if ('\x1b' != Sample(iRange,0,&lTotal)){
		if (0 == iRange){
			fMin = -10.0;
			fMax = +10.0;
		} else {
			fMin = -5.0;
			fMax = +5.0;
		}
		fBit = (fMax - fMin) / 4096.0 / 10.0;			//d
		fVolt = (float)(lTotal) / (float)(SAMPLESIZE);	//A/D擾
		fVolt = fVolt * (fMax - fMin) / 4096.0 + fMin;	//ۂ̓dɕϊ
		if (0.0 != fVolt)
			iOffset = (int)(fVolt / fBit);				//YʌvZ
		else
			iOffset = 0;
		iRes = AD02_cal_OFSS_ADJ(iOffset,gCardHd);
		if (SUCCESS == iRes)
			printf("\n̾ĔI");
		else
			printf("\n̾Ĕװ[%d]",iRes);
	}
}

//----- J[h\ -----
static void CardInfo(void)
{
unsigned short Addr;
int		Irq,iRes;

	iRes = AD02_info(gCardHd,&Addr,&Irq);
	if (SUCCESS == iRes)
		printf("\nCard No.%d , I/O Address %04X , INT %d",gCardHd,Addr,Irq);
	else
		printf("\nޏ擾װ[%d]",iRes);
}
//----- Ҳ -----
void main(void)
{
int		iKey,iRange=0;

	if (SUCCESS == AD02_init(&gCardHd)){					//ݒ
		do {
			printf("\n\n-------- Select --------------------------------");
			printf("\n  \'S\'  TvO");
			printf("\n  \'O\'  ItZbg");
			printf("\n  \'G\'  QC");
			printf("\n  \'U\'  ŐV[U[Zlݒ");
			printf("\n  \'H\'  }POuIiftHgZlj");
			printf("\n  \'L\'  }TuI@i@@@V@@@@j");
			printf("\n  \'C\'  Ou");
			printf("\n  \'I\'  J[h擾");
			printf("\n------------------------------------------------");
			iKey = getch();
			switch(toupper(iKey)){
				case 'S' :	SampleDisp(iRange); break;
				case 'O' :	Calib(iRange,0); break;
				case 'G' :	Calib(iRange,1); break;
				case 'H' :	ChgRange(iRange = 0); break;
				case 'L' :	ChgRange(iRange = 1); break;
				case 'U' :	iRange = SetLastCalib(iRange); break;
				case 'C' :	OffCalib(iRange); break;
				case 'I' :	CardInfo();break;
			}
		} while('\x1b' != iKey);
		AD02_close(gCardHd);								//I
	} else {
		printf("\nݒG[");
	}
}
