/*****************************************************************************
 *	Axpad02s.h
 *
 *	AXP-AD02
 *	Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
 *
 *	̃\[Xɂ̓bp[֐̎gpႪLqĂ܂B
 *
 *****************************************************************************/
#pragma once

#include <windows.h>
#include "Axpad02w.h"

using namespace System;
using namespace System::ComponentModel;
using namespace System::Collections;
using namespace System::Windows::Forms;
using namespace System::Data;
using namespace System::Drawing;

namespace SampleAd02
{
	/// <summary> 
	/// Axpad02s ̊Tv
	///
	/// x : ̃NX̖OύXꍇÃNXˑ邷ׂĂ .resx t@CɊ֘Atꂽ 
	///          }l[W \[X RpC c[ɑ΂ 'Resource File Name' vpeB 
	///          ύXKv܂B̕ύXsȂƁA
	///          fUCiƁÃtH[Ɋ֘Atꂽ[JCYς݃\[XƂA
	///          ݂ɗpłȂȂ܂B
	/// </summary>
	public __gc class Axpad02s : public System::Windows::Forms::Form
	{
	public: 
		Axpad02s(void)
		{
			InitializeComponent();
		}
        
	protected: 
		void Dispose(Boolean disposing)
		{
			if (disposing && components)
			{
				components->Dispose();
			}
			__super::Dispose(disposing);
		}
        
	private:
		/// <summary>
		/// KvȃfUCiϐłB
		/// </summary>
		System::ComponentModel::Container* components;

		static Axpad02w* Ad02w;

		/// <summary>
		/// fUCi T|[gɕKvȃ\bhłB̃\bh̓e
		/// R[h GfB^ŕύXȂłB
		/// </summary>
		void InitializeComponent(void)
		{
			// 
			// Axpad02s
			// 
			this->AutoScaleBaseSize = System::Drawing::Size(5, 12);
			this->ClientSize = System::Drawing::Size(292, 266);
			this->Name = S"Axpad02s";
			this->StartPosition = System::Windows::Forms::FormStartPosition::CenterScreen;
			this->Text = S"AXP-AD02 Sample";
			this->Load += new System::EventHandler(this, Axpad02s_Load);

		}		
		private: System::Void Axpad02s_Load(System::Object *  sender, System::EventArgs *  e)
		{
			String* szbuf;
			String* szTemp;
			int dwDllVer, dwDrvVer;
			bool bResult;				// 
			short wLogSocket;			// foCXi[
			Axpad02w::Resource* ri;		// \[X
			Axpad02w::Mode* md;			// 샂[h
			int dwNumData, dwStatus;
			short* pwBuffer;
			int i;
			Byte  bValue;
			int dwCh;
			int dwVRange;
			short wSingleData;

			Ad02w = new Axpad02w;
			md    = new Axpad02w::Mode;
			ri    = new Axpad02w::Resource;
			ri->dwMemBase		= new Int32[Axpad02w::MAX_MEM];
			ri->dwMemLength		= new Int32[Axpad02w::MAX_MEM];
			ri->dwMemAttrib		= new Int32[Axpad02w::MAX_MEM];
			ri->dwIOPortBase	= new Int32[Axpad02w::MAX_IO];
			ri->dwIOPortLength	= new Int32[Axpad02w::MAX_IO];
			ri->dwIRQRegisters	= new Int32[Axpad02w::MAX_IRQ];
			ri->dwIRQAttrib		= new Int32[Axpad02w::MAX_IRQ];
			ri->dwDMALst		= new Int32[Axpad02w::MAX_DMA];
			ri->dwDMAAttrib		= new Int32[Axpad02w::MAX_DMA];
			ri->dwReserved1		= new Int32[Axpad02w::MAX_RSV];

			// 
			ri->dwNumMemWindows = 0;
			for (i=0; i<Axpad02w::MAX_MEM; i++) {
				ri->dwMemBase[i]   = 0;
				ri->dwMemLength[i] = 0;
				ri->dwMemAttrib[i] = 0;
			}
			ri->dwNumIOPorts = 0;
			for (i=0; i<Axpad02w::MAX_IO; i++) {
				ri->dwIOPortBase[i]   = 0;
				ri->dwIOPortLength[i] = 0;
			}
			ri->dwNumIRQs = 0;
			for (i=0; i<Axpad02w::MAX_IRQ; i++) {
				ri->dwIRQRegisters[i] = 0;
				ri->dwIRQAttrib[i]    = 0;
			}
			ri->dwNumDMAs = 0;
			for (i=0; i<Axpad02w::MAX_DMA; i++) {
				ri->dwDMALst[i]    = 0;
				ri->dwDMAAttrib[i] = 0;
			}
			for (i=0; i<Axpad02w::MAX_RSV; i++)
				ri->dwReserved1[i] = 0;

			//--------------------	o[Wԍ\	----------------------------------
			// AXP-AD02 DLL,Driver̃o[Wԍ擾
			if (Ad02w->GetVersion(&dwDllVer, &dwDrvVer) == false) {
					ErrorMessage(Axpad02w::SOCKET_AUTO);
					return;
			}
			szbuf = String::Concat(S"GetVersion\n",
									String::Format(S"DLL: {0}H\n", dwDllVer.ToString("x8")),
									String::Format(S"DRV: {0}H",   dwDrvVer.ToString("x8")));
			ResultMessage(szbuf);
			//-----------------------  AXP-AD02̎gp錾	 -----------------------------
			wLogSocket = Axpad02w::SOCKET_AUTO;			// gp̃foCXT܂B
			bResult = Ad02w->Create(&wLogSocket, NULL, 0, NULL);
			if (bResult == false) {
				ErrorMessage(Axpad02w::SOCKET_AUTO);
				return;
			}
			szbuf = String::Concat(S"Created\n\n",
									String::Format(S"LogSocket: {0}", wLogSocket.ToString("d")));
			ResultMessage(szbuf);
			//-------------------------  \[X擾  -----------------------------
			if (Ad02w->GetResource(wLogSocket, ri) == false) {
				ErrorMessage(wLogSocket);
				return;
			}
			szbuf = String::Concat(String::Format(S"IO Address  \t: {0}H - {1}H\n",
													ri->dwIOPortBase[0].ToString("x4"),
													(ri->dwIOPortBase[0] + ri->dwIOPortLength[0] - 1).ToString("x4")),
									String::Format(S"IRQ         \t\t: {0}\n", 
													ri->dwIRQRegisters[0].ToString("d")));
			ResultMessage(szbuf);
			//------------------------  TvO[h̐ݒ  --------------------------
			md->cwBuffer		= 256;						// obt@TCYi[hPʁj
			md->dwChFirst		= 0;						// TvOJn`li0 ` 7j
			md->dwChLast		= 7;						// TvOŏI`li0 ` 7j
			md->dwSampleMode	= Axpad02w::SM_ONESHOT;		// TvO[h
			md->dwTimer			= 50;						// ^C}li1`255j
			md->dwTrigSource	= Axpad02w::TS_INTERNAL;	// gK\[X
			md->dwVoltageRange	= Axpad02w::VR_S10V;		// ͓dW

			if (Ad02w->SetMode(wLogSocket, md) == false) {
				ErrorMessage(wLogSocket);
				return;
			}
			szbuf = String::Concat(S"Sampling mode\n",
									String::Format(S"TvOJn`l = {0}\n", md->dwChFirst.ToString()),
									String::Format(S"TvOI`l = {0}\n", md->dwChLast.ToString()),
									String::Format(S"obt@TCY = {0}\n",             md->cwBuffer.ToString()),
									String::Format(S"^C}l = {0}\n",                   md->dwTimer.ToString()),
									String::Format(S"샂[h = {0}",					  md->dwSampleMode.ToString()));
			ResultMessage(szbuf);
			//----------------------------  TvOJn  ------------------------------
			if (Ad02w->StartSampling(wLogSocket) == false) {
				ErrorMessage(wLogSocket);
				return;
			}
			ResultMessage(S"Sampling started");
			//-----------------------  TvOXe[^X擾  -------------------------
			if (Ad02w->GetSamplingStatus(wLogSocket, &dwNumData, &dwStatus) == false) {
				ErrorMessage(wLogSocket);
				return;
			}
			szbuf = String::Concat(S"Sampling status\n",
									String::Format(S"f[^ = {0}\n", dwNumData.ToString()), 
									String::Format(S"Xe[^X = {0}H", dwStatus.ToString("x")));
			ResultMessage(szbuf);
			//--------------------------  TvOf[^擾  -------------------------
			if (dwNumData > 0) {
				pwBuffer = (short*)malloc(dwNumData * sizeof(short));
				if ( pwBuffer == NULL ) {
					ResultMessage("obt@mۂł܂ł" );
					return;
				}
				if (Ad02w->GetData(wLogSocket, pwBuffer, dwNumData) == false) {
					free(pwBuffer);
					ErrorMessage(wLogSocket);
					return;
				}
				szbuf = String::Concat(S"TvOf[^\n");
				// f[^100ҏW甲悤ɂ
				if (dwNumData > 100) dwNumData = 100;
				for (i = 0 ; i < dwNumData ; i++) {
					szTemp = String::Format(S"{0}:{1}H\t", 
											i.ToString("d2"), pwBuffer[i].ToString("x4"));
					szbuf = String::Concat(szbuf, szTemp);
					if ((i + 1) % 4 == 0)	// 4 Ŋ؂
						szbuf = String::Concat(szbuf, S"\n");
				}
				ResultMessage(szbuf);
				free(pwBuffer);
			}
			//----------------------------  TvO~  ------------------------------
			if (Ad02w->StopSampling(wLogSocket) == false) {
				ErrorMessage(wLogSocket);
				return;
			}
			ResultMessage(S"Sampling stop");

			//------------------------  VOTvOs  --------------------------
			dwCh = 0;
			dwVRange = Axpad02w::VR_S10V;
			if (Ad02w->SingleSampling( wLogSocket, dwCh, dwVRange, &wSingleData) == false) {
				ErrorMessage(wLogSocket);
				return;
			}
			szbuf = String::Concat(S"VOTvO\n",
									String::Format(S"`l {0}:{1}H", 
													dwCh.ToString(), wSingleData.ToString("x4")));
			ResultMessage(szbuf);

			//--------------------------  ėpo͂ɒlo  ------------------------------
			bValue = 0x0A;
			if (Ad02w->OutPort(wLogSocket, bValue) == false) {
				ErrorMessage(wLogSocket);
				return;
			}
			ResultMessage(String::Format(S"ėpo̓|[g {0}H o͂܂", bValue.ToString("x2")));

			//--------------------------  ėp͂̒l擾  ------------------------------
			if (Ad02w->InPort(wLogSocket, &bValue) == false) {
				ErrorMessage(wLogSocket);
				return;
			}
			ResultMessage(String::Format(S"ėp͒l : {0}H", bValue.ToString("x2")));

			//-----------------------------  foCXJ  -------------------------------
			if (Ad02w->Close( wLogSocket ) == false) {
				ErrorMessage(wLogSocket);
				return;
			}
			ResultMessage(S"Close");
			this->Close();
		}

		/*============================================================================
		// ʂ\
		//==========================================================================*/
		private: void ResultMessage(String* pszbuf)
		{
			MessageBox::Show(pszbuf, this->Text, 
								MessageBoxButtons::OK, MessageBoxIcon::Information);
		}

		/*============================================================================
		// װүނ\
		//==========================================================================*/
		private: void ErrorMessage(short wLogSocket)
		{
			int dwRes = Ad02w->GetLastError(wLogSocket);
			String* szBuf;

			switch (dwRes) {
				case Axpad02w::ERR_SYSTEM:
				case Axpad02w::ERR_WRAPDLL:
					dwRes = System::Runtime::InteropServices::Marshal::GetLastWin32Error();
					szBuf = String::Concat(S"System error\n\n",
											String::Format(S"Error code: {0}H", 
															dwRes.ToString("x8")));
					break;
				default:
					szBuf = String::Concat(S"AXP-AD02 error\n\n",
											String::Format(S"Error code: {0}H", 
															dwRes.ToString("x8")));
					break;
			}
			MessageBox::Show(szBuf, S"AXP-AD02 ERROR",
								MessageBoxButtons::OK, MessageBoxIcon::Stop);
		}
	};
}
