/*****************************************************************************
 *	Axpad02s.h
 *
 *	AXP-AD02
 *	Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
 *
 *	̃\[Xɂ̓bp[֐̎gpႪLqĂ܂B
 *
 *****************************************************************************/
#pragma once

#include <windows.h>
#include "Axpad02w.h"

namespace SampleAd02 {

	using namespace System;
	using namespace System::ComponentModel;
	using namespace System::Collections;
	using namespace System::Windows::Forms;
	using namespace System::Data;
	using namespace System::Drawing;

	/// <summary>
	/// Form1 ̊Tv
	///
	/// x: ̃NX̖OύXꍇÃNXˑ邷ׂĂ .resx t@CɊ֘Atꂽ
	///          }l[W \[X RpC c[ɑ΂ 'Resource File Name' vpeB
	///          ύXKv܂B̕ύXsȂƁA
	///          fUCiƁÃtH[Ɋ֘Atꂽ[JCYς݃\[XƂA
	///          ݂ɗpłȂȂ܂B
	/// </summary>
	public ref class Form1 : public System::Windows::Forms::Form
	{
	public:
		Form1(void)
		{
			InitializeComponent();
			//
			//TODO: ɃRXgN^ R[hǉ܂
			//
		}

	protected:
		/// <summary>
		/// gp̃\[XׂăN[Abv܂B
		/// </summary>
		~Form1()
		{
			if (components)
			{
				delete components;
			}
		}

	private:
		/// <summary>
		/// KvȃfUCiϐłB
		/// </summary>
		System::ComponentModel::Container ^components;

		static Axpad02w* Ad02w;

#pragma region Windows Form Designer generated code
		/// <summary>
		/// fUCi T|[gɕKvȃ\bhłB̃\bh̓e
		/// R[h GfB^ŕύXȂłB
		/// </summary>
		void InitializeComponent(void)
		{
			this->SuspendLayout();
			// 
			// Form1
			// 
			this->AutoScaleDimensions = System::Drawing::SizeF(6, 12);
			this->AutoScaleMode = System::Windows::Forms::AutoScaleMode::Font;
			this->ClientSize = System::Drawing::Size(292, 266);
			this->Name = L"Form1";
			this->StartPosition = System::Windows::Forms::FormStartPosition::CenterScreen;
			this->Text = L"AXP-AD02 Sample";
			this->Load += gcnew System::EventHandler(this, &Form1::Form1_Load);
			this->ResumeLayout(false);

		}
#pragma endregion
		private: System::Void Form1_Load(System::Object^  sender, System::EventArgs^  e) {
			String^ szbuf;
			String^ szTemp;
			int dwDllVer, dwDrvVer;
			bool bResult;				// 
			short wLogSocket;			// foCXi[
			Axpad02w::Resource* ri;		// \[X
			Axpad02w::Mode* md;			// 샂[h
			int dwNumData, dwStatus;
			short* pwBuffer;
			int i;
			Byte  bValue;
			int dwCh;
			int dwVRange;
			short wSingleData;

			Ad02w = new Axpad02w;
			md    = new Axpad02w::Mode;
			ri    = new Axpad02w::Resource;

			// 
			ri->dwNumMemWindows = 0;
			for (i=0; i<Axpad02w::MAX_MEM; i++) {
				ri->dwMemBase[i]   = 0;
				ri->dwMemLength[i] = 0;
				ri->dwMemAttrib[i] = 0;
			}
			ri->dwNumIOPorts = 0;
			for (i=0; i<Axpad02w::MAX_IO; i++) {
				ri->dwIOPortBase[i]   = 0;
				ri->dwIOPortLength[i] = 0;
			}
			ri->dwNumIRQs = 0;
			for (i=0; i<Axpad02w::MAX_IRQ; i++) {
				ri->dwIRQRegisters[i] = 0;
				ri->dwIRQAttrib[i]    = 0;
			}
			ri->dwNumDMAs = 0;
			for (i=0; i<Axpad02w::MAX_DMA; i++) {
				ri->dwDMALst[i]    = 0;
				ri->dwDMAAttrib[i] = 0;
			}
			for (i=0; i<Axpad02w::MAX_RSV; i++)
				ri->dwReserved1[i] = 0;

			//--------------------	o[Wԍ\	----------------------------------
			// AXP-AD02 DLL,Driver̃o[Wԍ擾
			if (Ad02w->GetVersion(&dwDllVer, &dwDrvVer) == false) {
					ErrorMessage(Axpad02w::SOCKET_AUTO);
					return;
			}
			szbuf = String::Concat("GetVersion\n",
									String::Format("DLL: {0:x8}H\n", dwDllVer),
									String::Format("DRV: {0:x8}H",   dwDrvVer));
			ResultMessage(szbuf);
			//-----------------------  AXP-AD02̎gp錾	 -----------------------------
			wLogSocket = Axpad02w::SOCKET_AUTO;			// gp̃foCXT܂B
			bResult = Ad02w->Create(&wLogSocket, NULL, 0, NULL);
			if (bResult == false) {
				ErrorMessage(Axpad02w::SOCKET_AUTO);
				return;
			}
			szbuf = String::Concat("Created\n\n",
									String::Format("LogSocket: {0}", wLogSocket));
			ResultMessage(szbuf);
			//-------------------------  \[X擾  -----------------------------
			if (Ad02w->GetResource(wLogSocket, ri) == false) {
				ErrorMessage(wLogSocket);
				return;
			}
			szbuf = String::Concat(String::Format("IO Address  \t: {0:x4}H - {1:x4}H\n",
													ri->dwIOPortBase[0],
													ri->dwIOPortBase[0] + ri->dwIOPortLength[0] - 1),
									String::Format("IRQ         \t\t: {0}\n", 
													ri->dwIRQRegisters[0]));
			ResultMessage(szbuf);
			//------------------------  TvO[h̐ݒ  --------------------------
			md->cwBuffer		= 256;						// obt@TCYi[hPʁj
			md->dwChFirst		= 0;						// TvOJn`li0 ` 7j
			md->dwChLast		= 7;						// TvOŏI`li0 ` 7j
			md->dwSampleMode	= Axpad02w::SM_ONESHOT;		// TvO[h
			md->dwTimer			= 50;						// ^C}li1`255j
			md->dwTrigSource	= Axpad02w::TS_INTERNAL;	// gK\[X
			md->dwVoltageRange	= Axpad02w::VR_S10V;		// ͓dW

			if (Ad02w->SetMode(wLogSocket, md) == false) {
				ErrorMessage(wLogSocket);
				return;
			}
			szbuf = String::Concat("Sampling mode\n",
									String::Format("TvOJn`l = {0}\n", md->dwChFirst),
									String::Format("TvOI`l = {0}\n", md->dwChLast),
									String::Format("obt@TCY = {0}\n",             md->cwBuffer),
									String::Format("^C}l = {0}\n",                   md->dwTimer),
									String::Format("샂[h = {0}",                   md->dwSampleMode));
			ResultMessage(szbuf);
			//----------------------------  TvOJn  ------------------------------
			if (Ad02w->StartSampling(wLogSocket) == false) {
				ErrorMessage(wLogSocket);
				return;
			}
			ResultMessage("Sampling started");
			//-----------------------  TvOXe[^X擾  -------------------------
			if (Ad02w->GetSamplingStatus(wLogSocket, &dwNumData, &dwStatus) == false) {
				ErrorMessage(wLogSocket);
				return;
			}
			szbuf = String::Concat("Sampling status\n",
									String::Format("f[^ = {0}\n",    dwNumData), 
									String::Format("Xe[^X = {0:x}H", dwStatus));
			ResultMessage(szbuf);
			//--------------------------  TvOf[^擾  -------------------------
			if (dwNumData > 0) {
				pwBuffer = (short*)malloc(dwNumData * sizeof(short));
				if ( pwBuffer == NULL ) {
					ResultMessage("obt@mۂł܂ł" );
					return;
				}
				if (Ad02w->GetData(wLogSocket, pwBuffer, dwNumData) == false) {
					free(pwBuffer);
					ErrorMessage(wLogSocket);
					return;
				}
				szbuf = String::Concat("TvOf[^\n");
				// f[^100ҏW甲悤ɂ
				if (dwNumData > 100) dwNumData = 100;
				for (i = 0 ; i < dwNumData ; i++) {
					szTemp = String::Format("{0:d2}:{1:x4}H\t", i, pwBuffer[i]);
					szbuf = String::Concat(szbuf, szTemp);
					if ((i + 1) % 4 == 0)	// 4 Ŋ؂
						szbuf = String::Concat(szbuf, "\n");
				}
				ResultMessage(szbuf);
				free(pwBuffer);
			}
			//----------------------------  TvO~  ------------------------------
			if (Ad02w->StopSampling(wLogSocket) == false) {
				ErrorMessage(wLogSocket);
				return;
			}
			ResultMessage("Sampling stop");

			//------------------------  VOTvOs  --------------------------
			dwCh = 0;
			dwVRange = Axpad02w::VR_S10V;
			if (Ad02w->SingleSampling( wLogSocket, dwCh, dwVRange, &wSingleData) == false) {
				ErrorMessage(wLogSocket);
				return;
			}
			szbuf = String::Concat("VOTvO\n",
									String::Format("`l {0}:{1:x4}H", 
													dwCh, wSingleData));
			ResultMessage(szbuf);

			//--------------------------  ėpo͂ɒlo  ------------------------------
			bValue = 0x0A;
			if (Ad02w->OutPort(wLogSocket, bValue) == false) {
				ErrorMessage(wLogSocket);
				return;
			}
			ResultMessage(String::Format("ėpo̓|[g {0:x2}H o͂܂", bValue));

			//--------------------------  ėp͂̒l擾  ------------------------------
			if (Ad02w->InPort(wLogSocket, &bValue) == false) {
				ErrorMessage(wLogSocket);
				return;
			}
			ResultMessage(String::Format("ėp͒l : {0:x2}H", bValue));

			//-----------------------------  foCXJ  -------------------------------
			if (Ad02w->Close( wLogSocket ) == false) {
				ErrorMessage(wLogSocket);
				return;
			}
			ResultMessage("Close");
			this->Close();
		}

		/*============================================================================
		// ʂ\
		//==========================================================================*/
		private: void ResultMessage(String^ pszbuf)
		{
			MessageBox::Show(pszbuf, this->Text, 
								MessageBoxButtons::OK, MessageBoxIcon::Information);
		}

		/*============================================================================
		// װүނ\
		//==========================================================================*/
		private: void ErrorMessage(short wLogSocket)
		{
			int dwRes = Ad02w->GetLastError(wLogSocket);
			String^ szBuf;

			switch (dwRes) {
				case Axpad02w::ERR_SYSTEM:
				case Axpad02w::ERR_WRAPDLL:
					dwRes = System::Runtime::InteropServices::Marshal::GetLastWin32Error();
					szBuf = String::Concat("System error\n\n",
											String::Format("Error code: {0}H", 
															dwRes.ToString("x8")));
					break;
				default:
					szBuf = String::Concat("AXP-AD02 error\n\n",
											String::Format("Error code: {0}H", 
															dwRes.ToString("x8")));
					break;
			}
			MessageBox::Show(szBuf, "AXP-AD02 ERROR",
								MessageBoxButtons::OK, MessageBoxIcon::Stop);
		}

	};
}

