Attribute VB_Name = "Sample"
'*****************************************************************************
'* axpad02s.frm                                                              *
'*                                                                           *
'* AXP-AD02                                                              *
'*                                                                           *
'* Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.                                   *
'*                                                                           *
'* Date Sep.2000                                                             *
'*                                                                           *
'* ̃\[Xɂ̓bp[֐̎gpႪLqĂ܂B                    *
'*                                                                           *
'*                                                                           *
'* FAd02wSingleSampling gpǉ                                      *
'*****************************************************************************
Option Explicit

Private Const szAD02 = "AXP-AD02"
Private Sub Main()
    Dim strbuf As String
    Dim dwDllVer As Long, dwDrvVer As Long
    Dim bResult As Boolean      ' 
    Dim wLogSocket As Integer   ' foCXi[
    Dim ri As AD02_RESOURCE     ' \[X
    Dim md As AD02_MODE         ' TvO[h
    Dim dwNumData As Long
    Dim dwStatus As Long
    Dim wData() As Integer
    Dim i As Long
    Dim bValue As Byte

    Dim dwCh As Long
    Dim dwVRange As Long
    Dim wSingleData As Integer

'---------------------------------------------------------------------------
' axpad02.dll ̎gp錾
    If Ad02wDllOpen() = False Then
        ErrorMessage (AD02_SOCKET_AUTO)
        Exit Sub                ' axpad02.dll ̃[hɎs܂
    End If
'---------------------------------------------------------------------------
' o[Wԍ\
    If Ad02wGetVersion(dwDllVer, dwDrvVer) = False Then  ' DLL,Driver̃o[Wԍ擾
        ErrorMessage (AD02_SOCKET_AUTO)
        Exit Sub
    End If

    strbuf = "GetVersion" + Chr(10) + _
             "DLL Version: &H" + Hex(dwDllVer) + Chr(10) + _
             "Driver Version: &H" + Hex(dwDrvVer)
    ResultMessage (strbuf)

'---------------------------------------------------------------------------
' AXP-AD02̎gp錾
    wLogSocket = AD02_SOCKET_AUTO     ' gp̃foCXT܂B
    
    ' ꍇA̎̃foCXi[܂B
    ' EBhEnhȂ̂ 0 Zbg܂B
    ' EBhEnhZbg΁Ae탁bZ[W܂B
    ' 3ԖڂɃZbgẮAbZ[WID̊ƂȂlłB
    ' ۂ̃bZ[WID͂̊lɃItZbg(WM_EOCȂ)̂ƂȂ܂B
    bResult = Ad02wCreate(wLogSocket, 0, &H6401, 0)
                                             
    If bResult = False Then         ' foCX܂B
        ErrorMessage (wLogSocket)
        Exit Sub
    End If
    
    strbuf = "AXP-AD02 Created" + Chr(10) + Chr(10) + _
          "LogSlot: " + Str(wLogSocket)

    ResultMessage (strbuf)

'---------------------------------------------------------------------------
' \[X擾
    If Ad02wGetResource(wLogSocket, ri) = False Then
        ErrorMessage (wLogSocket)
        Exit Sub
    End If

    strbuf = "Board Name: " + szAD02 + Chr(10) + _
             "IO Base Address: &H" + Hex(ri.dwIOPortBase(1)) + _
             "-&H" + Hex(ri.dwIOPortBase(1) + ri.dwIOPortLength(1) - 1) + Chr(10) + _
             "IRQ: " + Str(ri.dwIRQRegisters(1))

    ResultMessage (strbuf)

'---------------------------------------------------------------------------
' TvO[h̐ݒ
    md.cwBuffer = 256                   ' obt@TCYi[hPʁj
    md.dwChFirst = 0                    ' TvOJn`li0 ` 7j
    md.dwChLast = 0                     ' TvOŏI`li0 ` 7j
    md.dwSampleMode = AD02_SM_ONESHOT   ' TvO[h
    md.dwTimer = 50                     ' ^C}li1`255j
    md.dwTrigSource = AD02_TS_INTERNAL  ' gK\[X
    md.dwVoltageRange = AD02_VR_S10V    ' ͓dW

    If Ad02wSetMode(wLogSocket, md) = False Then
        ErrorMessage (wLogSocket)
        Exit Sub
    End If

    strbuf = "AXP-AD02 Sampling Mode" + Chr(10) + _
             "TvOJn`l=" + Str(md.dwChFirst) + Chr(10) + _
             "TvOI`l=" + Str(md.dwChLast) + Chr(10) + _
             "obt@TCY=" + Str(md.cwBuffer) + Chr(10) + _
             "^C}l=" + Str(md.dwTimer) + Chr(10) + _
             "샂[h=" + Str(md.dwSampleMode)

    ResultMessage (strbuf)

'---------------------------------------------------------------------------
    ' TvOJn
    If Ad02wStartSampling(wLogSocket) = False Then
        ErrorMessage (wLogSocket)
        Exit Sub
    End If

    ResultMessage ("AXP-AD02 Sampling Started")

'---------------------------------------------------------------------------
    ' TvOEXe[^X̎擾
    If Ad02wGetSamplingStatus(wLogSocket, dwNumData, dwStatus) = False Then
        ErrorMessage (wLogSocket)
        Exit Sub
    End If

    strbuf = "TvOEXe[^X擾" + Chr(10) + _
             "f[^=" + Str(dwNumData) + Chr(10) + _
             "Xe[^X=" + Str(dwStatus)

    ResultMessage (strbuf)

'---------------------------------------------------------------------------
    ' TvOς݃f[^̎擾
    If dwNumData > 0 Then
        ReDim wData(1 To dwNumData)
    
        If Ad02wGetData(wLogSocket, wData, dwNumData) = False Then
            ErrorMessage (wLogSocket)
            Exit Sub
        End If
    
        If dwNumData > 99 Then      ' f[^99ҏW甲悤ɂ
            dwNumData = 99
        End If
    
        strbuf = "TvOς݃f[^擾" + Chr(10)
        For i = 1 To dwNumData
            strbuf = strbuf + Str(i) + ":&H" + Hex(wData(i)) + "  "
    
            If (i + 1) Mod 4 = 0 Then   ' 4 Ŋ؂
                strbuf = strbuf + Chr(10)
            End If
        Next i
    
        ResultMessage (strbuf)
    End If

'---------------------------------------------------------------------------
    ' TvO~
    If Ad02wStopSampling(wLogSocket) = False Then
        ErrorMessage (wLogSocket)
        Exit Sub
    End If

    ResultMessage ("AXP-AD02 Sampling Stopped")

'---------------------------------------------------------------------------
    ' VOTvOs

    dwCh = 0
    dwVRange = AD02_VR_S10V

    If Ad02wSingleSampling(wLogSocket, dwCh, dwVRange, wSingleData) = False Then
        ErrorMessage (wLogSocket)
        Exit Sub
    End If

    strbuf = "VOTvO" + Chr(10) + _
             "`l " + Str(dwCh) + ": " + Hex(wSingleData)

    ResultMessage (strbuf)

'---------------------------------------------------------------------------
    ' ėp͂̒l擾
    If Ad02wInPort(wLogSocket, bValue) = False Then
        ErrorMessage (wLogSocket)
        Exit Sub
    End If

    strbuf = "ėp͒l:&H" + Hex(bValue)
    ResultMessage (strbuf)
'---------------------------------------------------------------------------
    ' ėpo͂ɒlo
    bValue = &HA
    If Ad02wOutPort(wLogSocket, bValue) = False Then
        ErrorMessage (wLogSocket)
        Exit Sub
    End If

    ResultMessage ("ėpo͂ &HAo͂܂")
'---------------------------------------------------------------------------
    ' AXP-AD02̎gpJ
    If Ad02wClose(wLogSocket) = False Then
        ErrorMessage (wLogSocket)
        Exit Sub
    End If

    ResultMessage ("AXP-AD02 Closed")
'---------------------------------------------------------------------------
    ' axpad02.dll ̎gpJ
    If Ad02wDllClose() = False Then
        MsgBox "DLL Unload error", vbOKOnly + vbCritical
        Exit Sub        ' axpad02.dll ̃A[hɎs܂B
    End If

End Sub

' ʂ\
Private Sub ResultMessage(lpszbuf As String)
    
    MsgBox lpszbuf, vbOKOnly + vbInformation

End Sub


' G[bZ[W\
Private Sub ErrorMessage(wLogSocket As Integer)
    
    Dim dwRes As Long
    Dim szbuf As String
    
    dwRes = Ad02wGetLastError(wLogSocket)

    Select Case dwRes
    Case AD02_ERR_WRAPDLL
        szbuf = "DLL Load error"

    Case Else                           ' ̑̒l̏ꍇB
        szbuf = "AXP-AD02 error" + Chr(10) + Chr(10) + _
                "Error code: &H" + _
                Hex(dwRes)
    End Select

    MsgBox szbuf, vbOKOnly + vbCritical


End Sub
