Attribute VB_Name = "Wrapper"
'*****************************************************************************
'* axpad02w.bas                                                              *
'*                                                                           *
'* AXP-AD02                                                              *
'*                                                                           *
'* Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.                                   *
'*                                                                           *
'* Date Nov.1998                                                             *
'*                                                                           *
'*****************************************************************************
Option Explicit
Declare Function LoadLibrary Lib "kernel32" Alias "LoadLibraryA" (ByVal lpLibFileName As String) As Long
Declare Function FreeLibrary Lib "kernel32" (ByVal hLibModule As Long) As Long
Declare Function GetProcAddress Lib "kernel32" (ByVal hModule As Long, ByVal lpProcName As String) As Long

Global Const AD02_DLL_NAME = "Axpad02.dll"  ' DLL
Dim hDLL As Long                            ' DLLւ̃nh
Global Const AD02_ERR_WRAPDLL = -1          ' bp[֐G[
'*****************************************************************************
'*    axpad02.dll[h                                                *
'*                                                                   *
'* ߂l  True                                                          *
'*        s False                                                         *
'*****************************************************************************
Function Ad02wDllOpen() As Boolean
    Ad02wDllOpen = False
    If hDLL <> 0 Then Exit Function
    hDLL = LoadLibrary(AD02_DLL_NAME)
    If hDLL = 0 Then Exit Function
    If Ad02wGetDllExportFunc() = False Then
        Ad02wDllClose     ' DLL GNX|[g֐LmFɎŝŁADLL N[Y
        Exit Function
    End If
    Ad02wDllOpen = True
End Function
'*****************************************************************************
'*    axpad02.dllA[h                                            *
'*                                                                   *
'* ߂l  True                                                          *
'*        s False                                                         *
'*****************************************************************************
Function Ad02wDllClose() As Boolean
    Ad02wDllClose = True
    If hDLL = 0 Then Exit Function
    If FreeLibrary(hDLL) <> 0 Then hDLL = 0 Else Ad02wDllClose = False
End Function
'*****************************************************************************
'*    AXP-AD02 DLL,Driver̃o[Wԍ擾                            *
'*    pdwDllVer DLLo[Wԍi[                                  *
'*        pdwDrvVer Drivero[Wԍi[                               *
'* ߂l  True                                                          *
'*        s False                                                         *
'*****************************************************************************
Function Ad02wGetVersion(ByRef pdwDllVer As Long, ByRef pdwDrvVer As Long) As Boolean
    Ad02wGetVersion = False
    If hDLL = 0 Then Exit Function
    If Ad02GetVersion(pdwDllVer, pdwDrvVer) = 0 Then Exit Function
    Ad02wGetVersion = True
End Function
'*****************************************************************************
'*    AXP-AD02̔Cӂ̃foCX̎gp錾                               *
'*    pwLogSocket gpfoCXi[AhX                     *
'*        hWnd      bZ[W𑗂EBhEnh                       *
'*        uWMBase   ƂȂ郁bZ[WID                                   *
'*        pvInitArg gp(0Zbg)                                        *
'* ߂l  True                                                          *
'*        s False                                                         *
'*****************************************************************************
Function Ad02wCreate(ByRef pwLogSocket As Integer, ByVal hWnd As Long, ByVal uWMBase As Long, ByRef pvInitArg As Long) As Boolean
    Ad02wCreate = False
    If hDLL = 0 Then Exit Function
    If Ad02Create(pwLogSocket, hWnd, uWMBase, pvInitArg) = 0 Then Exit Function
    Ad02wCreate = True
End Function
'*****************************************************************************
'*    AXP-AD02̔Cӂ̃foCX̎gpJ                               *
'*    wLogSocket gpfoCX                                        *
'* ߂l  True                                                          *
'*        s False                                                         *
'*****************************************************************************
Function Ad02wClose(ByVal wLogSocket As Integer) As Boolean
    Ad02wClose = False
    If hDLL = 0 Then Exit Function
    If Ad02Close(wLogSocket) = 0 Then Exit Function
    Ad02wClose = True
End Function
'*****************************************************************************
'*    wfoCX̃\[X擾                                   *
'*    wLogSocket ׂfoCX                                          *
'*        pres     \[Xi[\                              *
'* ߂l  True                                                          *
'*        s False                                                         *
'*****************************************************************************
Function Ad02wGetResource(ByVal wLogSocket As Integer, ByRef pres As AD02_RESOURCE) As Boolean
    Ad02wGetResource = False
    If hDLL = 0 Then Exit Function
    If Ad02GetResource(wLogSocket, pres) = 0 Then Exit Function
    Ad02wGetResource = True
End Function
'*****************************************************************************
'*    TvO[h̐ݒ                                           *
'*    wLogSocket ݒ肷foCX                                        *
'*        pmode    [hݒf[^̃AhX                                *
'* ߂l  True                                                          *
'*        s False                                                         *
'*****************************************************************************
Function Ad02wSetMode(ByVal wLogSocket As Integer, ByRef pmode As AD02_MODE) As Boolean
    Ad02wSetMode = False
    If hDLL = 0 Then Exit Function
    If Ad02SetMode(wLogSocket, pmode) = 0 Then Exit Function
    Ad02wSetMode = True
End Function
'*****************************************************************************
'*    TvOJn                                                   *
'*    wLogSocket JnfoCX                                        *
'* ߂l  True                                                          *
'*        s False                                                         *
'*****************************************************************************
Function Ad02wStartSampling(ByVal wLogSocket As Integer) As Boolean
    Ad02wStartSampling = False
    If hDLL = 0 Then Exit Function
    If Ad02StartSampling(wLogSocket) = 0 Then Exit Function
    Ad02wStartSampling = True
End Function
'*****************************************************************************
'*    TvO~                                                   *
'*    wLogSocket ~foCX                                        *
'* ߂l  True                                                          *
'*        s False                                                         *
'*****************************************************************************
Function Ad02wStopSampling(ByVal wLogSocket As Integer) As Boolean
    Ad02wStopSampling = False
    If hDLL = 0 Then Exit Function
    If Ad02StopSampling(wLogSocket) = 0 Then Exit Function
    Ad02wStopSampling = True
End Function
'*****************************************************************************
'*    TvOEXe[^X̎擾                                     *
'*    wLogSocket   擾foCX                                      *
'*        pcwData f[^obt@                                           *
'*        pdwStatus  Xe[^X                                              *
'* ߂l  True                                                          *
'*        s False                                                         *
'*****************************************************************************
Function Ad02wGetSamplingStatus(ByVal wLogSocket As Integer, ByRef pcwData As Long, ByRef pdwStatus As Long) As Boolean
    Ad02wGetSamplingStatus = False
    If hDLL = 0 Then Exit Function
    If Ad02GetSamplingStatus(wLogSocket, pcwData, pdwStatus) = 0 Then Exit Function
    Ad02wGetSamplingStatus = True
End Function
'*****************************************************************************
'*    TvOς݃f[^̎擾                                       *
'*    wLogSocket  擾foCX                                       *
'*        pwData    f[^obt@                                           *
'*        cwData    ǂݏof[^                                         *
'* ߂l  True                                                          *
'*        s False                                                         *
'*****************************************************************************
Function Ad02wGetData(ByVal wLogSocket As Integer, ByRef pwData() As Integer, ByVal cwData As Long) As Boolean
    Ad02wGetData = False
    If hDLL = 0 Then Exit Function
    If Ad02GetData(wLogSocket, pwData(LBound(pwData)), cwData) = 0 Then Exit Function
    Ad02wGetData = True
End Function
'*****************************************************************************
'*    ėp͂̒l擾                                                 *
'*    wLogSocket  擾foCX                                       *
'*        bpValue     li[ꏊ̃AhX                             *
'* ߂l  True                                                          *
'*        s False                                                         *
'*****************************************************************************
Function Ad02wInPort(ByVal wLogSocket As Integer, ByRef pbValue As Byte) As Boolean
    Ad02wInPort = False
    If hDLL = 0 Then Exit Function
    If Ad02InPort(wLogSocket, pbValue) = 0 Then Exit Function
    Ad02wInPort = True
End Function
'*****************************************************************************
'*    ėpo̓|[gɒlo                                           *
'*    wLogSocket  擾foCX                                       *
'*        pValue      o͂l                                             *
'* ߂l  True                                                          *
'*        s False                                                         *
'*****************************************************************************
Function Ad02wOutPort(ByVal wLogSocket As Integer, ByVal bValue As Byte) As Boolean
    Ad02wOutPort = False
    If hDLL = 0 Then Exit Function
    If Ad02OutPort(wLogSocket, bValue) = 0 Then Exit Function
    Ad02wOutPort = True
End Function
'*****************************************************************************
'*    VOTvOf[^擾                                     *
'*    wLogSocket     擾foCX                                    *
'*        dwCh           Ώۃ`l                                      *
'*        dwVoltageRange dW                                          *
'*        pwData         TvOς݃f[^i[̈                *
'* ߂l  True                                                          *
'*        s False                                                         *
'*****************************************************************************
Function Ad02wSingleSampling(ByVal wLogSocket As Integer, ByVal dwCh As Long, ByVal dwVoltageRange As Long, ByRef pwData As Integer) As Boolean
    Ad02wSingleSampling = False
    If hDLL = 0 Then Exit Function
    If Ad02SingleSampling(wLogSocket, dwCh, dwVoltageRange, pwData) = 0 Then Exit Function
    Ad02wSingleSampling = True
End Function
'*****************************************************************************
'*    AXP-AD02̃G[R[h                                             *
'*    wLogSocket  G[foCX                               *
'* ߂l G[R[h                                                       *
'*****************************************************************************
Function Ad02wGetLastError(ByVal wLogSocket As Integer) As Long
    Ad02wGetLastError = AD02_ERR_WRAPDLL
    If hDLL = 0 Then Exit Function
    Ad02wGetLastError = Ad02GetLastError(wLogSocket)
End Function
'*---------------------------------------------------------------------------*
'*    DLLGNX|[g֐L̊mF                                      *
'*                                                                   *
'* ߂l  True                                                          *
'*        s False                                                         *
'*---------------------------------------------------------------------------*
Private Function Ad02wGetDllExportFunc() As Boolean
    Dim pFunc As Long

    Ad02wGetDllExportFunc = False
    ' Ad02GetVersion ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Ad02GetVersion")
    If pFunc = 0 Then Exit Function
    ' Ad02Create ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Ad02Create")
    If pFunc = 0 Then Exit Function
    ' Ad02Close ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Ad02Close")
    If pFunc = 0 Then Exit Function
    ' Ad02GetResource ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Ad02GetResource")
    If pFunc = 0 Then Exit Function
    ' Ad02SetMode ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Ad02SetMode")
    If pFunc = 0 Then Exit Function
    ' Ad02StartSampling ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Ad02StartSampling")
    If pFunc = 0 Then Exit Function
    ' Ad02StopSampling ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Ad02StopSampling")
    If pFunc = 0 Then Exit Function
    ' Ad02GetSamplingStatus ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Ad02GetSamplingStatus")
    If pFunc = 0 Then Exit Function
    ' Ad02GetData ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Ad02GetData")
    If pFunc = 0 Then Exit Function
    ' Ad02InPort ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Ad02InPort")
    If pFunc = 0 Then Exit Function
    ' Ad02OutPort ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Ad02OutPort")
    If pFunc = 0 Then Exit Function
    ' Ad02SingleSampling ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Ad02SingleSampling")
    If pFunc = 0 Then Exit Function
    ' Ad02GetLastError ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Ad02GetLastError")
    If pFunc = 0 Then Exit Function

    Ad02wGetDllExportFunc = True  ' SĂ DLL GNX|[g֐݂̑mF

End Function








